<template>
  <v-card v-if="loaded">
    <v-progress-linear height="8" :color="pourcentage === 100 ? 'success': 'primary-lighten-1'" :model-value="pourcentage"></v-progress-linear>
    <v-toolbar
      class="px-2"
      color="surface"
      extension-height="10"
    >
      <v-toolbar-title class="text-primary"><slot name="title"></slot></v-toolbar-title>
      <v-spacer></v-spacer>
      <share-btn></share-btn>
      <template #extension>
        <p class="px-6">{{ collection.nbCompletedItems }} items completed on {{ collection.nbItems }}</p>
      </template>
    </v-toolbar>
    <v-card-text class="px-0">
      <v-virtual-scroll
        class="px-4"
        max-height="75vh"
        :items="collection.items"
      >
          <template v-slot:default="{ item, index }">
            <v-scroll-x-transition>
              <ck-master-item
                @setup-create="setupEdit(item.ordre+1)"
                class="my-2 animated"
                :item="item"
                :collection-id="collectionId"
                :focus-on-mount="index + itemIndexStart === 1"
                :tabindex="index + itemIndexStart"
                @SWITCH_CHECK="switchCheck(item)"
                @PUT_ITEM_AT="((itemToCreate, itemType, ordre) => createItem(itemToCreate, itemType, ordre))"
                @UPDATE_SIMPLE_ITEM="(itemToCreate) => updateSimpleItem(item.id, itemToCreate)"
                @DELETE="deleteItem(item)"
              ></ck-master-item>
            </v-scroll-x-transition>
          </template>
      </v-virtual-scroll>
      <warn-empty-collection
        v-if="collection.items === undefined || !collection.items.length > 0"
        @create-item="setupEdit(0)"
      ></warn-empty-collection>
    </v-card-text>
    <v-progress-linear reverse height="8" :color="pourcentage === 100 ? 'success': 'primary-lighten-1'" :model-value="pourcentage"></v-progress-linear>
  </v-card>
  <item-from-dialog :collection-id="collectionId" v-model="isEditing" :order="order"></item-from-dialog>
</template>

<script>
import CkMasterItem from '@/components/item/ck-master-item.vue'
import { mapState } from 'pinia'
import { useCollectionsStore } from '@/stores/itemCollections.js'
import { useModesStore } from '@/stores/modes.js'
import ItemFromDialog from '@/components/item/item-from-dialog.vue'
import WarnEmptyCollection from '@/components/item-collection/warn-empty-collection.vue'
import ShareBtn from '@/components/commons/share-btn.vue'

export default {
  name: "ck-item-collection",
  components: { ShareBtn, WarnEmptyCollection, ItemFromDialog, CkMasterItem },
  data() {
    return {
      isEditing: false,
      timer: undefined,
      order: 0,
    }
  },
  props: {
    collectionId: {
      type: String,
      required: true,
    },
    itemIndexStart: {
      type: Number,
      default: 1,
    },
    checklistId: {
      type: String,
      required: true
    }
  },
  computed: {
    ...mapState(useCollectionsStore, {
      getByCollectionId: 'getByCollectionId',
    }),
    collection() {
      return this.getByCollectionId(this.collectionId)
    },
    loaded() {
      return this.collection !== undefined
    },
    pourcentage() {
      return (100*this.collection.nbCompletedItems)/this.collection.nbItems
    },
  },
  created() {
    useCollectionsStore().fetchCollection(this.collectionId)
  },
  mounted() {
    this.timer = setInterval(() => {
      if (useModesStore().fastMode)
        useCollectionsStore().fetchCollection(this.collectionId)
    }, useModesStore().fastModeFrequency)
  },
  beforeUnmount() {
    clearInterval(this.timer)
  },
  methods: {
    setupEdit(order) {
      this.order = order
      this.isEditing = true
    },
    switchCheck(item) {
      if (item.ticked) {
        useCollectionsStore().uncheckSimpleItem(this.collection.collectionId, item.id)
      } else {
        useCollectionsStore().checkSimpleItem(this.collection.collectionId, item.id)
      }
    },
    updateSimpleItem(itemToUpdateId,itemToUpdateFrom) {
      useCollectionsStore().updateSimpleItem(this.collection.collectionId, itemToUpdateId, itemToUpdateFrom)
    },
  }
}
</script>

<style scoped>

</style>